import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import org.apache.commons.io.IOUtils;
import org.json.JSONObject;
import org.json.simple.parser.JSONParser;
import java.io.FileWriter;
import java.security.MessageDigest;
import java.io.BufferedInputStream;
import java.io.BufferedWriter;

import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.Closeable;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.zip.CRC32;
import java.util.zip.CheckedInputStream;
import com.adventnet.servicedesk.server.utils.SDDataManager;

//$Id$

public class FindVulnerableFiles {

	public static void main(String args[]){

		

		List<String> modifiedFilesInPpm = new ArrayList<String>();

		modifiedFilesInPpm.add("/bin/restoreData.bat");
		modifiedFilesInPpm.add("/bin/startSDP.bat ");
		modifiedFilesInPpm.add("/pgsql/data/archive.bat ");
		
		List<String> dynamicFiles = new  ArrayList<String>(); 	

		List<String> filesDeleted = new ArrayList<String>();

		List<String> filesModified = new ArrayList<String>();

		List<String> filesAdded = new ArrayList<String>();

		JSONObject customerCheckSumObject = new JSONObject();

		List<String> extensions = new ArrayList<String>();

		extensions.add(".exe");

		extensions.add(".bat");

		extensions.add(".msi");

		extensions.add(".vbs");

		List<String> directoryNotAllowed = new ArrayList<String>();

		directoryNotAllowed.add("fileAttachments");

		directoryNotAllowed.add("inlineimages");

		directoryNotAllowed.add("logs");

		directoryNotAllowed.add("images");

		directoryNotAllowed.add("backup");

		directoryNotAllowed.add("licenses");

		directoryNotAllowed.add("archive");

		try{

			JSONObject direcJSONObject = new JSONObject();

			String maindirpath = System.getProperty("server.dir");

			File vulnerableFile = new File(maindirpath + "/FindVulnerableFile/vulnerablefiles.txt" );

			if(!vulnerableFile.exists()){

					vulnerableFile.createNewFile();

			}

        	FileWriter fw = new FileWriter(vulnerableFile.getAbsoluteFile());

		    BufferedWriter bw = new BufferedWriter(fw);

			System.out.println("----------------------------Scanning in progress---------------------------------\n\n");

			String versionNumber = SDDataManager.getInstance().getBuildNumber();

			System.out.println("\nCurrent Version: " + versionNumber+"\n");

			if(Long.valueOf(versionNumber) >= 11138  && Long.valueOf(versionNumber) < 11306){

				File maindir = new File(maindirpath);

				if (maindir.exists() && maindir.isDirectory()) {

					File arr[] = maindir.listFiles();

					iterateFiles(arr, 0, 0,direcJSONObject,extensions,directoryNotAllowed);

				}

				boolean setupAffected = false;

				customerCheckSumObject.put("ServiceDesk"+"_Directory",direcJSONObject);

				if(direcJSONObject.has("bin_Directory")){

					JSONObject binJSONObject = direcJSONObject.getJSONObject("bin_Directory");

					if(binJSONObject.has("msiexec.exe") && !binJSONObject.get("msiexec.exe").equals("4065004583")){

						setupAffected = true;

					}

				}

				if(!setupAffected){

					setupAffected = isSetupAffected();

				}

				//checking application logs here to find if it has vulnerable URLs logs
				if( setupAffected )
				{
					System.out.println("Your server has been compromised by an Unauthenticated RCE attack. Isolate the ServiceDesk Plus server from the network immediately and contact ServiceDesk Plus support for more assistance.\n");
				}


				if(!setupAffected){

					JSONObject originalCheckSumObject = readOriginalVersionCheckSumObject(versionNumber);

					CompareCheckSumObject(customerCheckSumObject,originalCheckSumObject,filesModified,filesDeleted,dynamicFiles,"");

					getAddedFiles(customerCheckSumObject,originalCheckSumObject,filesAdded,filesModified,dynamicFiles,"");

					boolean vulnerable = false;

					boolean ppmsetup = false;

					int count = 0;

					for(String files : modifiedFilesInPpm){

						if(filesModified.contains(files)){

							count = count + 1;

						}

					}

					if(count == 3){

						ppmsetup = true;

					}else{

						for(String files : filesAdded){

							if(getFileExtension(files).equals(".sh")){

								ppmsetup = true;

								break;
							}

						}

					}

					if(	!ppmsetup ){

						if(filesAdded.size() != 0){
   

							bw.write("\nList of unknown files detected :\n" );

							int i =1;

							for(String file : filesAdded ){

								bw.write(i+")"+file+"\n");

								i++;

							}

							vulnerable = true;

							//System.out.println("");

						}
						if(filesModified.size() != 0){

							bw.write("\nList of modified ServiceDesk Plus configuration files :\n");

							int i = 1;

							for(String file : filesModified ){

								if(!file.startsWith("/Patch")){

									String diff = readFileSizeAndCheckFileModifiedOrNot(file,versionNumber);

									bw.write(i+")"+file+ diff +"\n");

									i++;
										
								}

							}

							vulnerable = true;


						}

						if(!vulnerable){

							System.out.println("You are using a vulnerable version of ServiceDesk Plus and it may have been compromised by an Unauthenticated RCE attack. The impact of the reported Unauthenticated RCE attack is critical for ServiceDesk Plus setups that are configured to be accessed publicly. Contact ServiceDesk Plus support for more assistance. \n");

							//System.out.println("\nKindly upgrade to latest version of ServiceDeskPlus\n");

						}else{

							System.out.println("\nUnknown and/or modified files have been detected in your server. Please send the vulnerablefiles.txt from ManageEngine/ServiceDesk/FindVulnerableFile to \"support@servicedeskplus.com\" and mention the subject as \"CVE-2021-44077\" so that we can check if your server has been compromised.\n");

						}

					}else{

						// PPM CHECK

						//System.out.println("Ppm Setup..");

						List<String> filesModifiedPpm = new ArrayList<String>();

						List<String> filesAddedPpm = new ArrayList<String>();

						List<String> filesDeletedPpm = new ArrayList<String>();

						JSONObject originalPpmCheckSumObject = readOriginalPpmVersionCheckSumObject(versionNumber);

						CompareCheckSumObject(customerCheckSumObject,originalPpmCheckSumObject,filesModifiedPpm,filesDeletedPpm,dynamicFiles,"");

						getAddedFiles(customerCheckSumObject,originalPpmCheckSumObject,filesAddedPpm,filesModifiedPpm,dynamicFiles,"");

						boolean vulnerablePpm = false;

						if(filesAddedPpm.size() != 0){

							bw.write("\nList of unknown files detected :\n" );

							int i =1;

							for(String file : filesAddedPpm ){

								bw.write(i+")"+file+"\n");
								i++;

							}

							vulnerablePpm = true;

							//System.out.println("");

						}

						if(filesModifiedPpm.size() != 0){

							bw.write("\nList of modified ServiceDeskPlus configuration files :\n");
							int i = 1;

							for(String file : filesModifiedPpm ){

									if(!file.startsWith("/Patch")){

										String diff = readFileSizeAndCheckFileModifiedOrNot(file,versionNumber);

										bw.write(i+")"+file+ diff +"\n");

									    i++;


								}

							}

							vulnerablePpm = true;

						}

						if(!vulnerablePpm){


							System.out.println("You are using a vulnerable version of ServiceDesk Plus and it may have been compromised by an Unauthenticated RCE attack. The impact of the reported Unauthenticated RCE attack is critical for ServiceDesk Plus setups that are configured to be accessed publicly. Contact ServiceDesk Plus support for more assistance. \n");

							//System.out.println("\nKindly upgrade to latest version of ServiceDeskPlus\n");

						}else{

							System.out.println("\nUnknown and/or modified files have been detected in your server. Please send the vulnerablefiles.txt from ManageEngine/ServiceDesk/FindVulnerableFile to \"support@servicedeskplus.com\" and mention the subject as \"CVE-2021-44077\" so that we can check if your server has been compromised.\n");

						}

					}

				}

			}else{

				if(Long.valueOf(versionNumber) < 11138){

					System.out.println("You are using ServiceDesk Plus build "+versionNumber+". This is vulnerable to authenticated RCE attacks and we recommend that you upgrade to the latest version of ServiceDesk Plus.\n");

				}else if(Long.valueOf(versionNumber) >= 11306){

					System.out.println("The installed version "+versionNumber+" is not vulnerable to Unauthenticated RCE attacks; however, we recommend that you upgrade to the latest version of ServiceDesk Plus.\n");

				}

			}

			bw.close();

		}catch(Exception e){

			e.printStackTrace();

		}

	}

	static JSONObject readOriginalVersionCheckSumObject( String versionNumber)throws Exception{

		InputStream is = new FileInputStream(System.getProperty("server.dir") + File.separator + "FindVulnerableFile" + File.separator +"AllversionCheckSum"+File.separator+ "checkSumFile" + versionNumber +".json");

		String jsonTxt = IOUtils.toString(is, "UTF-8");

		JSONObject allCheckSumObject = new JSONObject(jsonTxt);

		return (JSONObject) allCheckSumObject.get(versionNumber);

	}

	static JSONObject readOriginalPpmVersionCheckSumObject( String versionNumber)throws Exception{

		InputStream is = new FileInputStream(System.getProperty("server.dir") + File.separator + "FindVulnerableFile" + File.separator +"AllversionCheckSum"+File.separator+ "checkSumFile" + versionNumber +"_ppm.json");

		String jsonTxt = IOUtils.toString(is, "UTF-8");

		JSONObject allCheckSumObject = new JSONObject(jsonTxt);

		return (JSONObject) allCheckSumObject.get(versionNumber);

	}

	static void CompareCheckSumObject(JSONObject customerCheckSumObject, JSONObject originalCheckSumObject, List<String> filesModified,List<String> filesDeleted,List<String> dynamicFiles,String tempKey){

		for(String key : originalCheckSumObject.keySet()){

			if(key.endsWith("_Directory")){

				if(customerCheckSumObject.has(key)){

					if(key.replace("_Directory","").equals("ServiceDesk")){

						tempKey = "";

					}else{

						tempKey = tempKey + "/"+ key.replace("_Directory","");

					}

					CompareCheckSumObject(customerCheckSumObject.getJSONObject(key),originalCheckSumObject.getJSONObject(key),filesModified,filesDeleted,dynamicFiles,tempKey);

					String[] tempKeys = tempKey.split("/");

					tempKey = "";

					for(int i =0 ; i < tempKeys.length-1 ; i++){

						if(tempKey == ""){

							tempKey = tempKey + tempKeys[i];

						}else{

							tempKey = tempKey +"/" + tempKeys[i];

						}

					}

					// System.out.println(tempKey);

				}else{

					if(tempKey.equals("")){

						filesDeleted.add("/" + key);

					}else{

						filesDeleted.add("/" + tempKey + "/" + key);

					}

				}

			}else{

				if(customerCheckSumObject.has(key) && !customerCheckSumObject.get(key).equals(originalCheckSumObject.get(key))){

					// if(!dynamicFiles.contains(tempKey)){

					if(tempKey.equals("")){

						filesModified.add("/" + key);

					}else{

						filesModified.add(tempKey + "/" + key);

					}

					// }

				}else if(!customerCheckSumObject.has(key)){

					if(tempKey.equals("")){

						filesDeleted.add("/" + key);

					}else{

						filesDeleted.add(tempKey + "/" + key);

					}
				}

			}

		}

	}

	static void getAddedFiles(JSONObject customerCheckSumObject, JSONObject originalCheckSumObject,List<String> filesAdded,List<String> filesModified,List<String> dynamicFiles,String tempKey){

		for(String key : customerCheckSumObject.keySet()){

			if(key.endsWith("_Directory")){

				if(originalCheckSumObject.has(key)){


					if(key.replace("_Directory","").equals("ServiceDesk")){

						tempKey = "";

					}else{

						tempKey = tempKey + "/"+ key.replace("_Directory","");

					}

					getAddedFiles(customerCheckSumObject.getJSONObject(key),originalCheckSumObject.getJSONObject(key),filesAdded, filesModified,dynamicFiles,tempKey);


					String[] tempKeys = tempKey.split("/");

					tempKey = "";

					for(int i =0 ; i < tempKeys.length-1 ; i++){

						if(tempKey == ""){

							tempKey = tempKey + tempKeys[i];

						}else{

							tempKey = tempKey +"/" + tempKeys[i];

						}

					}


				}

			}else{

				if(!originalCheckSumObject.has(key) && !key.startsWith("FindVulnerableFile") && !key.startsWith("RCEScan")  ){

					if(!dynamicFiles.contains(tempKey)){

						//if(!getFileExtension(key).equals(".sh")){

						if(tempKey == ""){

							if(key.equals("msiexec.exe")){

								if( customerCheckSumObject.has(key) && !customerCheckSumObject.get(key).equals("4065004583") ){

									filesModified.add("/"+key);

								}


							}else{

								filesAdded.add("/"+key);

							}

						}else{

							if(key.equals("msiexec.exe")){

								if( customerCheckSumObject.has(key) && !customerCheckSumObject.get(key).equals("4065004583") ){

									filesModified.add(tempKey + "/" +key);

								}


							}else{

								filesAdded.add(tempKey + "/" +key);

							}

							//if(!(key.equals("msiexec.exe") && customerCheckSumObject.has(key) && customerCheckSumObject.get(key).equals("4065004583"))){

							//	filesAdded.add(tempKey+"/"+key);

							//}

						}

						//}

					}


				}

			}

		}
	}

	static void iterateFiles(File[] fileList, int index, int level,JSONObject direcJSONObject,List<String> extensions,List<String> directoryNotAllowed) throws Exception{

		// terminate condition
		if (index == fileList.length)
			return;

		// tabs for internal levels

		if (fileList[index].isFile()){

			if(extensions.contains(getFileExtension(fileList[index].getName()))){

				if(getFileExtension(fileList[index].getName()).equals(".conf")) {

					if(fileList[index].getName().startsWith("wrapper")){

						String checksum = getCheckSumValueForFile(fileList[index].getAbsolutePath());

						direcJSONObject.put(fileList[index].getName(), checksum);

					}

				}else if(getFileExtension(fileList[index].getName()).equals(".xml")){

					if(fileList[index].getName().equals("web.xml") || fileList[index].getName().equals("struts-config.xml")){

						String checksum = getCheckSumValueForFile(fileList[index].getAbsolutePath());

						direcJSONObject.put(fileList[index].getName(), checksum);

					}else if( fileList[index].getName().startsWith("security")){

						String path[] = fileList[index].getAbsolutePath().split("\\\\");

						if(path[path.length -2].equals("security") && path[path.length -3].equals("WEB-INF") && (path[path.length -4].equals("ROOT") || path[path.length -4].equals("sd"))){

							String checksum = getCheckSumValueForFile(fileList[index].getAbsolutePath());

							direcJSONObject.put(fileList[index].getName(), checksum);

						}

					}

				}else{

					String checksum = getCheckSumValueForFile(fileList[index].getAbsolutePath());

					direcJSONObject.put(fileList[index].getName(), checksum);

				}

			}

		}

		// for sub-directories
		else if (fileList[index].isDirectory()) {


			JSONObject tempJSONObject = new JSONObject();

			if(!directoryNotAllowed.contains(fileList[index].getName())){

				// recursion for sub-directories
				iterateFiles(fileList[index].listFiles(), 0, level + 1, tempJSONObject, extensions,directoryNotAllowed);

				direcJSONObject.put(fileList[index].getName()+"_Directory", tempJSONObject);

			}

		}

		// recursion for main directory
		iterateFiles(fileList, ++index, level,direcJSONObject, extensions,directoryNotAllowed);

	}

	static String getCheckSumValueForFile(String fileName) throws Exception{

		
		Long checksum = null;
		FileInputStream file = null;
		BufferedInputStream in = null;

		try
		{
			file = new FileInputStream(fileName);
			CheckedInputStream check = new CheckedInputStream(file, new CRC32());
			in = new BufferedInputStream(check);
			int ch = 0;

			do 
			{
				ch = in.read();
				// Read file in completely. 
			} while (ch != -1);

			checksum = check.getChecksum().getValue();
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		finally
		{
			try 
			{
				if(file != null) 
				{ 
					file.close(); 
				}
				if(in != null) 
				{
					in.close(); 
				}
			} 
			catch(Exception e) 
			{
				e.printStackTrace();
			}
		}

		return String.valueOf(checksum);

	}

	static void writeJSONObjectToFile(JSONObject object,String filePath){

		FileWriter file = null;

		try {
			// Constructs a FileWriter given a file name, using the platform's default charset
			file = new FileWriter(filePath);

			file.write(object.toString());

		} catch (Exception e) {
			e.printStackTrace();

		} finally {

			try {

				file.flush();

				file.close();

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	static String getFileExtension(String name) {

		int lastIndexOf = name.lastIndexOf(".");

		if (lastIndexOf == -1) {

			return ""; // empty extension

		}

		return name.substring(lastIndexOf);

	}

	//*********** Log finder code here ************************
	private static boolean isSetupAffected()
	{
		BufferedReader reader = null;

		try 
		{
			String ImportTechniciansAction = "ImportTechniciansAction", fileNameIs= "fileName is : ";

			File folder = new File(System.getProperty("server.dir")+File.separator+"logs");

			String[] logs = folder.list();

			for (int i = 0; i < logs.length; i++) 
			{
				if( logs[i].startsWith("serverout") )
				{
					File f = new File( folder.getCanonicalPath()+File.separator+logs[i] );

					reader  = new BufferedReader(new FileReader(f));

					String str;

					while( (str = reader.readLine()) != null )
					{
						if( str.contains(ImportTechniciansAction) )
						{
							System.out.println("INFO : Vulnerable file upload URL called; trace in "+logs[i]);

							if( str.contains(fileNameIs) )
							{
								String uploadFile = str.substring( str.indexOf(fileNameIs)+fileNameIs.length(), str.length()-1 );

								boolean isMsiexec = str.contains("msiexec.exe");

								if( isMsiexec || !uploadFile.endsWith(".csv") )
								{
									System.out.println("WARNING : Vulnerable file upload URL called with non CSV file ; file name is "+uploadFile+" ; trace in "+logs[i]);

									if( isMsiexec )
									{
										System.out.println("ERROR : Malicious file found!");

										return true;
									}
								}
							}
						}
					}

					close(reader);
				}
			} 

		}
		catch (Exception e) {
			e.printStackTrace();
			System.out.println("*****\nIssue occured while checking logs. Kindly contact our support*********************************\n");
		}
		finally
		{
			close(reader);
		}

		return false;
	}

	private static void close(Closeable... object) 
	{
		try {
			for (int i = 0; i < object.length; i++) 
			{
				if( object[i] != null )
				{
					object[i].close();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static String readFileSizeAndCheckFileModifiedOrNot(String fileName,String versionNumber){

		Long diff =  new Long(0);

		JSONObject versionFileSize = new JSONObject();

		try{

        		versionFileSize = readOriginalVersionFileSize(versionNumber);

				long size = Files.size(Paths.get(System.getProperty("server.dir")+ File.separator+ fileName));

				//System.out.println(size);

				String[] directories = fileName.split("\\/");

				int i = 0;

				JSONObject tempJSONObject = new JSONObject();

				long currentFileSize = new Long(0);

				while (i != directories.length){



					if(i==0){

						tempJSONObject = versionFileSize.getJSONObject("ServiceDesk_Directory");

					}else if(i == directories.length-1){

						currentFileSize = Long.parseLong(tempJSONObject.get(directories[i]).toString());

						//System.out.println(tempJSONObject.get(directories[i]));

					}else{

						tempJSONObject = tempJSONObject.getJSONObject(directories[i]+"_Directory");

					}

					i++;


				}

				

				if(size > currentFileSize){

					diff = size - currentFileSize;

					return "(+"+String.valueOf(diff) +")bytes";

				}else if(size < currentFileSize){

					diff = currentFileSize - size;

					return "(-"+String.valueOf(diff) +")bytes";

				}

				return String.valueOf(diff); 

				

				//System.out.print(diff);

			


			}catch(Exception e ){

					e.printStackTrace();

			}

			return String.valueOf(diff);

	}


	static JSONObject readOriginalVersionFileSize( String versionNumber)throws Exception{

		InputStream is = new FileInputStream(System.getProperty("server.dir") + File.separator + "FindVulnerableFile" + File.separator +"size"+File.separator+ "fileSize" + versionNumber +".json");

		String jsonTxt = IOUtils.toString(is, "UTF-8");

		JSONObject allFileSize = new JSONObject(jsonTxt);

		return (JSONObject) allFileSize.get(versionNumber);

	}
}
